<?php
/* guest_uploader
	author: team1/3
	name : guest_uploader
	released: 2014/10/04
	coyright(c) SpiQe Software,team1/3 All Rights Reserved.
*/

function guest_uploader($opt) {
	global $html,$database,$params,$config,$ut,$p_circle;

	if (check_rights('edit')) {
		return;
	}
	if (isset($html['meta']['snippet_uploader']['main'])) {
		return;
	}

$tmp = <<<EOT
	<script>
	ot.uploader = {};
	ot.open_uploader = function (opt) {
		if(ot.tryitEditor) { ot.tryitEditor.save_cursor(); }
		opt = opt || {};
		var u = "ajax=*open_uploader";
		if (opt.title) {
			u += '&title='+encodeURIComponent(opt.title);
		}
		if (ot.otoken) {
			u += '&otoken='+ot.otoken;
		}
		if (opt.resize) {
			u += '&resize='+encodeURIComponent(opt.resize);
			ot.uploader.resize = opt.resize;
		}
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: u
			, dataType:'json'
			, opt:opt
			, success: function(data){
				if (data && data['result'] && data['html']) {
					\$("#onethird-uploader-dialog").remove();
					\$('body').append('<div id="onethird-uploader-dialog" class="onethird-dialog " >'+data['html']+'</div>');
					ot.open_dialog(\$("#onethird-uploader-dialog").width(800));
					ot.read_image_list(data['img_list'],data['img_url']);
					if (this.opt['resize']) {
						var resize = this.opt['resize'];
						\$('.onethird-uploader-unit input[name=resize]').each(function(){
							if (parseInt(\$(this).attr('data-x')) >= resize) {
								\$(this).attr('checked','checked');
								return false;
							}
						});
					}
				} else {
				}
			}
		});
		if (opt['select']) {
			ot.uploader['select'] = opt['select'];
		}
	};
	ot.uploader.on = function(ev,obj) {
		if (ot.uploader[ev]) {
			ot.uploader[ev](obj);
		}
	};
	ot.upfile_dragover = function() {
		event.stopPropagation();
		event.preventDefault();
		event.dataTransfer.dropEffect = 'copy';
    };
	ot.upfile_drop = function() {
		event.stopPropagation();
		event.preventDefault();
		ot.upload(event);
    };
	ot.upload = function(event) {
		var files;
		if (event.target && event.target.files) {
			files = event.target.files;
		} else if (event.dataTransfer && event.dataTransfer.files) {
			files = event.dataTransfer.files;
		} else {
			return;
		}
		reader_ar = [];
		image_ar = [];
		for (var i = 0; i < files.length; i++) {
			var file = files[i];
			var type = file.type;
			if (!type) {
				var tmp = file.name.split('.'); 
				if (tmp.length>1) {
					type = tmp[tmp.length-1];
				}
			}
			var is_resize = (/jpeg/i).test(type);
			if ((/png/i).test(type) && file.size > 1024*50) {
				is_resize = true;
			}
			var max_width = \$('input[name="resize"]:checked').attr('data-x');
			var max_height = \$('input[name="resize"]:checked').attr('data-y');
			if(is_resize && max_width>0 && max_height>0) {
				reader_ar[i] = new FileReader();
				reader_ar[i].readAsDataURL(file);
				reader_ar[i].fname = file.name;
				\$('#onethird-uploader-list').append("<div class='onethird-loading item' ><p><img src='{$config['site_url']}/img/loading.gif' /><br /><span>resizing...</span></p><div>");
				var a = \$('#onethird-uploader-list .onethird-loading');
				a.attr('data-count',a.attr('data-count')+1);
				reader_ar[i].onload = function (event) {
					image_ar[i] = new Image();
					image_ar[i].src = event.target.result;
					image_ar[i].fname = this.fname;
					image_ar[i].onload = function() {
						ot.resize_img(this);
					}
				};
				continue;

			} else if((/image/i).test(type) || (/(zip|pdf|word|docx|excel|xlsx|powerpoint|pptx|csv)/i).test(type)) {
				reader_ar[i] = new FileReader();
				reader_ar[i].readAsDataURL(file);
				reader_ar[i].fname = file.name;
				reader_ar[i].onload = function (event) {
					var data = event.target.result;
					var u = "ajax=*set_uploaded&data="+encodeURIComponent(data)+'&id='+ot.uploader['gallery_id'];
					if (ot.uploader.name) {
						u += '&name='+ot.uploader.name;
					}
					if (this.fname) {
						u += '&fname='+encodeURIComponent(this.fname);
					}
					if (ot.otoken) {
						u += '&otoken='+ot.otoken;
					}
					if ((/image/i).test(type) && ot.uploader.resize) {
						var resize_no = \$('input[name="resize"]:checked').attr('data-z');
						if (resize_no !== '' || parseInt(resize_no) > 0 ) {
							u += '&resize='+encodeURIComponent(ot.uploader.resize);
							u += '&resize_no='+resize_no;
						}
					}
					ot.ajax({
						type: "POST"
						, url: '{$_SERVER['REQUEST_URI']}'
						, data: u
						, dataType:'json'
						, success: function(data){
							if ( data && data['result'] ) {
								ot.draw_image( data['url'], data['name'] );
							} else {
								alert('file type error.');
							}
							var a = \$('#onethird-uploader-list .onethird-loading');
							if (a.attr('data-count') >0) {
								a.attr('data-count',a.attr('data-count')-1);
							} else {
								a.remove();
								\$('.onethird-uploader-unit #files').val('');
							}
						}
					});
					\$('#onethird-uploader-list').append("<img src='{$config['site_url']}/img/loading.gif' class='onethird-loading' />");
					var a = \$('#onethird-uploader-list .onethird-loading');
					a.attr('data-count',a.attr('data-count')+1);
				};
			} else {
				alert('file type error ('+type+')');
			}
		}
	};
	ot.resize_img = function(obj) {
		var canvas = document.createElement('canvas');

		var width = obj.width;
		var height = obj.height;
		var max_width = \$('input[name="resize"]:checked').attr('data-x');
		var max_height = \$('input[name="resize"]:checked').attr('data-y');
		var resize_no = \$('input[name="resize"]:checked').attr('data-z');

		if (width > height) {
			if (width > max_width) {
				height = Math.round(height *= max_width / width);
				width = max_width;
			}
		} else {
			if (height > max_height) {
				width = Math.round(width *= max_height / height);
				height = max_height;
			}
		}
	  
		canvas.width = width;
		canvas.height = height;
		var ctx = canvas.getContext("2d");
		ctx.drawImage(obj, 0, 0, width, height);
		quality = 1;
		if (\$('input[name="resize"]:checked').attr('data-quality')) {
			quality = \$('input[name="resize"]:checked').attr('data-quality');
		}
		var data = canvas.toDataURL("image/jpeg", parseFloat(quality));
		var u = "ajax=*set_uploaded&data="+encodeURIComponent(data)+'&id='+ot.uploader['gallery_id'];
		if (obj.fname) {
			u += '&fname='+obj.fname;
		}
		if (resize_no !==''  || parseInt(resize_no) > 0 ) {
			u += '&resize_no='+resize_no;
		}
		if (ot.otoken) {
			u += '&otoken='+ot.otoken;
		}
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: u
			, dataType:'json'
			, success: function(data){
				var a = \$('#onethird-uploader-list .onethird-loading');
				if ( data && data['result'] ) {
					ot.draw_image( data['url'], data['name'] );
					if (a.attr('data-count') >0) {
						a.attr('data-count',a.attr('data-count')-1);
					} else {
						a.remove();
						\$('.onethird-uploader-unit #files').val('');
					}
				} else {	
					alert('error');
					a.remove();
					\$('.onethird-uploader-unit #files').val('');
				}
			}
			, error: function() {
				var a = \$('#onethird-uploader-list .onethird-loading');
				alert('error');
				a.remove();
				\$('.onethird-uploader-unit #files').val('');
			}
		});
	};
	ot.read_image_list = function(img_list,image_url) {
		var i;
		for (i in img_list) {
			var image_name = img_list[i];
			ot.draw_image(image_url+image_name,image_name);
		}
	};
	ot.draw_image = function( file_url, image_name ) {
		if (!image_name) { return; }
		var img,delhnd,ogphnd,thumbhnd;
		var ok = false;
		\$('#onethird-uploader-list .item').each(function(){
			if (\$(this).attr('data-src')==image_name) {
				\$(this).remove();
			}
		});
		if (image_name.match(/(png|gif|jpg|jpeg)$/i)) {
			img = \$("<img src='"+file_url+"' class='picture' onclick='ot.uploader.on(\"select\",this)' >").load(function(e){
				\$(this).attr('title','image : '+this.naturalWidth+' x '+this.naturalHeight);
				if (this.naturalWidth < 301) {
					\$(this).css('padding','15px');
				} else if (this.naturalWidth < 600) {
					\$(this).css('padding','5px');
				}
			});
		} else {
			img = \$("<p data-url='"+file_url+"' data-name='"+image_name+"' onclick='ot.uploader.on(\"select\",this)'>{$ut->icon('zip'," width='20' ")}<br /><span >"+image_name+"</span></p>");
		}

		delhnd = \$("{$ut->icon('delete'," class='hnd' style='bottom:2px;left:2px;width:15px;height:15px' title='Remove'")}").click(function(event){
			event.stopPropagation();
			ot.remove_picture(this);
		});

		var o = \$("<div class='item' data-src='"+image_name+"'></div>").append(img);
EOT;
		if (!isset($opt['remove']) || $opt['remove']!==false) {
$tmp .= <<<EOT
			o.append(delhnd);
EOT;
		}
$tmp .= <<<EOT
		\$('#onethird-uploader-list').append(o);
	};
EOT;
		if (!isset($opt['remove']) || $opt['remove']!==false) {
$tmp .= <<<EOT
		ot.remove_picture = function ( obj ){
			var o = \$(obj).parent();
			var a = o.attr('data-src');
			if (!confirm("remove data.\\n do you want execute?")) {
				event.preventDefault();
				return;
			}
			var id = ot.uploader['gallery_id'];
			var opt = '';
			if (ot.otoken) {
				opt += '&otoken='+ot.otoken;
			}
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=*remove_picture&src="+a+"&id="+id+opt
				, dataType:'json'
				, obj:obj
				, success: function(data){
					if ( data && data['result'] ) {
						\$(this.obj).parent().removeClass('ogp');
						if (!data['remain']) {
							\$(this.obj).parent().fadeOut('slow'
								, function(){
									\$(this).remove();
									if (ot.uploader['show_information']) {
										ot.uploader.show_information();
									}
								}
							);
						}
					} else {
						alert("Failed to remove.");
					}
				}
			});
		};
EOT;
	}
$tmp .= <<<EOT
	</script>
EOT;
	$html['meta']['snippet_uploader']['main'] = $tmp;

	if (isset($_POST['ajax']) && $_POST['ajax'] == '*open_uploader')  {
		if (!empty($opt['uploader_resize'])) {
			$uploader_resize = $opt['uploader_resize'];
		} else {
			$uploader_resize = array(array(320,240),array(640,480),array(1200,630),array(0,0));
		}
		$r = array();
		$r['result'] = true;
		if (!empty($opt['group'])) {
			$group = $opt['group'];
		} else {
			$id = $params['page']['id'];
		}
		$group_path_info = '';
		$thumb = false;
		if (isset($_POST['id'])) {
			$id =  (int)($_POST['id']);
		}
		if (!empty($params['page']['block_type']) && $params['page']['block_type'] == 5) {
			$id = $params['page']['link'];
		}
		$r['group'] = $group;
		if ($group) {
			$f = $config['files_path'].DIRECTORY_SEPARATOR.'img';
			$u = "{$config['files_url']}/img";
			$group_path_info = $config['files_url'].'img';
			if (substr($group,0,1) == '.') {
				$name = substr($group,1);
				$f = $params['circle']['files_path'].DIRECTORY_SEPARATOR.'data';
				if (substr($params['circle']['files_url'],0,strlen($params['circle']['url'])) == $params['circle']['url']) {
					$x = substr($params['circle']['files_url'],strlen($params['circle']['url']));
					$u = 'timg.php?p='.$name.'&amp;i=';
					$group_path_info = "timg.php (files/{$p_circle}/data/$name)";
				} else {
					$u = $params['circle']['files_url'].'data/'.$name.'/';
					$group_path_info = $u;
				}
			} else {
				$name = $group;
				$u = 'img.php?p='.$name.'&amp;i=';
				$group_path_info = "img.php (files/{$p_circle}/img/$name)";
			}
			$f .= DIRECTORY_SEPARATOR.$name;
			$r['img_url'] = $u;
		} else {
			$f = $config['files_path'].DIRECTORY_SEPARATOR.'img'.DIRECTORY_SEPARATOR.$id;
			$image_url = 'img.php?p='.$id.'&amp;i=';
			$group_path_info = "img.php (files/{$p_circle}/img/$id)";
			$r['img_url'] = $image_url;
			$group = $id;
		}

		$image_ar = array();
		if (is_dir($f)) {
			$ar = @scandir( $f );
			foreach ($ar as $v) {
				if (preg_match("/\.(jpeg|jpg|gif|png|zip|pdf|doc|docx|xls|xlsx|ppt|pptx|csv)$/i",$v)) {
					if (is_file($f.DIRECTORY_SEPARATOR.$v)) {
						$image_ar[] = $v;
					}
				}
			}
		}
		$r['img_list'] = $image_ar;
		$title = 'Select File';
		if (isset($_POST['title'])) {
			$title = sanitize_str($_POST['title']);
		}
		$resize_mode = 'Jpeg';
		if (isset($_POST['resize'])) {
			$t = explode(',',$_POST['resize']);
			if (count($t) > 0) {
				$t2 = array();
				foreach($t as $v) {
					if ($v=='auto') {
						$resize_mode = 'Auto';
						continue;
					}
					$v = explode('/',$v);
					if (count($v) >= 2 || count($v) <= 4) {
						$t2[] = $v;
					}
				}
				if (count($t2) > 0) {$uploader_resize=$t2;}
			}
		}
$a = <<<EOT
	<div class='title'>{$title}</div>
	<div class='onethird-uploader-unit'  >
		<div id="onethird-uploader-list" class='list clearfix' ondragover="ot.upfile_dragover()" ondrop="ot.upfile_drop()" >
		</div>
		<div class='actions'>
			<span title='resize' > $resize_mode resize </span> : 
EOT;
			foreach ($uploader_resize as $k=>$v) {
				if (!empty($v[2])) {
					$c = ' checked ';
				} else {
					$c = '';
				}
				$q = '';
				if (isset($v[3])) {
					$c .= " data-quality='{$v[3]}'  ";
					$q = "({$ut->str($v[3]*100)}%)";
				}
				if ($v[0]) {
$a .= <<<EOT
					<label ><input type='radio' name='resize' data-x='{$v[0]}' data-y='{$v[1]}' data-z='{$k}' $c />{$v[0]}/{$v[1]}px{$q}</label>
EOT;
				} else {
$a .= <<<EOT
					<label ><input type='radio' name='resize' data-x='{$v[0]}' data-y='{$v[1]}' data-z='' $c />no-resize</label>
EOT;
				}
			}
$a .= <<<EOT
			<div style='margin:10px 0 15px 0;' >
				folder : $group_path_info
			</div>
EOT;
$a .= <<<EOT
			<div class='btn-panel'>
				<input type='button' class='onethird-button' value='Close' onclick='ot.close_dialog("#onethird-uploader-dialog")' />
				<span class='upload-button onethird-button'>
					<span class='inner'>
						<span>Upload</span>
						<input type="file" id="files" name="files[]" multiple onchange='ot.upload(event)' />
					</span>
				</span>
			</div>
		</div>
	</div>
EOT;
		$r['html'] = $a;
		echo( json_encode($r) );
		exit();
	}

	if (isset($_POST['ajax']) && $_POST['ajax'] == '*set_uploaded' && isset($_POST['data']))  {
		$r = array();
		$r['result'] = false;

		$id = (int)$_POST['id'];
		if (isset($_POST['resize_no'])) {
			set_cookie("uploader_resize", (int)$_POST['resize_no']);
		}
		if (isset($_POST['page'])) {
			$id =  (int)($_POST['page']);
		}
		if (!empty($params['page']['block_type']) && $params['page']['block_type'] == 5) {
			$id = $params['page']['link'];
		}

		$f = $config['files_path'].DIRECTORY_SEPARATOR.'img';
		if (!is_dir($f)) {
			if (!mkdir($f)) {
				$r['error1'] = $f;
				echo( json_encode($r) );
				exit();
			}
			chmod($f, $config['permission']);  
		}

		if (!empty($opt['group'])) {
			$group = $opt['group'];
		} else {
			$id = $params['page']['id'];
			$group = '';
		}
		if ($group) {
			$f = $config['files_path'].DIRECTORY_SEPARATOR.'img';
			$u = $config['files_url'].'img';
			if (substr($group,0,1) == '.') {
				$name = substr($group,1);
				$f = $params['circle']['files_path'].DIRECTORY_SEPARATOR.'data';
				if (substr($params['circle']['files_url'],0,strlen($params['circle']['url'])) == $params['circle']['url']) {
					$x = substr($params['circle']['files_url'],strlen($params['circle']['url']));
					$u = 'timg.php?p='.$name.'&amp;i=';
				} else {
					$u = $params['circle']['files_url'].'data/'.$name;
				}
			} else {
				$name = $group;
				$u = 'img.php?p='.$group.'&amp;i=';
			}
			$f .= DIRECTORY_SEPARATOR.$name;
			$f .= DIRECTORY_SEPARATOR;
		} else {
			$f = $config['files_path'].DIRECTORY_SEPARATOR.'img'.DIRECTORY_SEPARATOR.$id.DIRECTORY_SEPARATOR;
			$u = 'img.php?p='.$id.'&amp;i=';
		}
		if (!is_dir($f)) {
			if (!mkdir($f)) {
				$r['error2'] = $f;
				echo( json_encode($r) );
				exit();
			}
			chmod($f, $config['permission']);  
		}

		$type_ar = array('jpeg'=>1,'jpg'=>1,'gif'=>1,'png'=>1,'zip'=>1,'pdf'=>1,
		'doc'=>1,'docx'=>1,'ppt'=>1,'pptx'=>1,'xls'=>1,'xlsx'=>1,'csv'=>1);
		
		$pos = strpos($_POST['data'],';base64,');
		$r['pos'] = $pos;
		$path_parts = pathinfo($_POST['fname']);
		$r['ext'] = $ext = strtolower($path_parts['extension']);
		$safe_name = $path_parts['filename'].'.'.$r['ext'];
		
		if ($pos > 1 && isset($type_ar[$ext])) {
			$mine = substr($_POST['data'],0,$pos);
			$r['type'] = false;
			$r['mine'] = $mine;
			if (strstr($mine,"word") || strstr($mine,"officedocument") || strstr($mine,"zip") || strstr($mine,"pdf")|| $mine=="data:") {
				$r['type'] = 'file';
			}
			if (strstr($mine,"image")) {
				$r['type'] = 'img';
			}
			$r['fname'] = $_POST['data'];
			if ($r['type']) {
				$b = base64_decode(substr($_POST['data'], $pos+7));
				$name = '';
				if ($r['type'] == 'img') {
					$r['org_name'] = $name;
					$name = md5($b);
					$name .= '.'.$ext;
				} else {
					$name = sanitize_str($safe_name);
				}
				if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN' && strlen($name) != mb_strlen($name)) {
					$name = md5($b);
					$name .= '.'.$ext;
				} else {
					$name = preg_replace("/[ ()]/","",$name);
				}
				$r['name'] = $name;
				$r['path'] = $f;
				if (is_file($f.$name)) {
					@unlink($f.$name);
				}
				if (@file_put_contents($f.$name, $b)) {
					@chmod($f.$name,$config['permission']);
					if (!check_rights('edit')) {
						add_actionlog("[login user upload] ({$_SESSION['login_id']} : {$_SESSION['login_name']} : {$_SERVER['REMOTE_ADDR']})");
					}
					$r['result'] = true;
					$r['url'] = $u.$name;
					$r['name'] = $name;
					
					if (isset($_POST['resize']) && strstr($_POST['resize'],'auto')!==false) {
						if (isset($_POST['resize_no']) && $params['uploader']['uploader_resize'][(int)$_POST['resize_no']]) {
							$w = $params['uploader']['uploader_resize'][(int)$_POST['resize_no']][0];
							$h = $params['uploader']['uploader_resize'][(int)$_POST['resize_no']][1];
							$r['resize_mode'] = 'Auto';
							$path_parts = pathinfo($f.$name);
							$new_img_name = $path_parts['dirname'].DIRECTORY_SEPARATOR.'r_'.$path_parts['basename'];
							$r['new_img_name'] = $new_img_name;
							if (save_resize($f.$name, $new_img_name, $w, $h)) {
								@unlink($f.$name);
								@chmod($new_img_name,$config['permission']);
								$name = basename($new_img_name);
								$r['result'] = true;
								$r['url'] = $u.$name;
								$r['name'] = $name;
								$r['resize_mode_ok'] = 'true';
							} else {
								$r['resize_mode_ok'] = 'false';
							}
						}
					}
				}
			}
		}

		echo( json_encode($r) );
		exit();
	}
	if (isset($_POST['ajax']) && $_POST['ajax'] == '*remove_picture')  {
		$r = array();
		if (!isset($opt['remove']) || $opt['remove']!==false) {
		} else {
			echo( json_encode($r) );
			exit();
		}
		$p_src = sanitize_str($_POST['src']);
		$p_id = sanitize_str($_POST['id']);	
		$r['p_id'] = $p_id;
		$r['p_src'] = $p_src;
		if (!empty($params['page']['block_type']) && $params['page']['block_type'] == 5) {
			$p_id = $params['page']['link'];
		}
		if (!empty($opt['group'])) {
			$p_group = $opt['group'];
		} else {
			$p_page = $params['page']['id'];
			$p_group = false;
		}
		$r['p_group'] = $p_group;
		if ($p_group) {
			if (substr($p_group,0,1) == '.') {
				$file = $params['circle']['files_path'].DIRECTORY_SEPARATOR.'data'.DIRECTORY_SEPARATOR.substr($p_group,1).DIRECTORY_SEPARATOR.$p_src;
			} else {
				$file = $config['files_path'].DIRECTORY_SEPARATOR.'img'.DIRECTORY_SEPARATOR.$p_group.DIRECTORY_SEPARATOR.$p_src;
			}
		} else {
			$file = $config['files_path'].DIRECTORY_SEPARATOR.'img'.DIRECTORY_SEPARATOR.$p_page.DIRECTORY_SEPARATOR.$p_src;
		}
		
		$r['result'] = @unlink($file);

		$r['file'] = $file;
		echo( json_encode($r) );
		exit();
	}

}

?>